####################################################################################
# R program (does not use any BUGS model)
# 
# A. salmon life cycle model
# Estimate probability of extinction for various values of harvest rate h
# 
# Run the programs "SimulSeeSelune_p_Extint_WithOverlap.R"
#                  and
#                  "SimulSeeSelune_p_Extint_WithoutOverlap.R" 
# 
# Chapter 12
# 
####################################################################################


source("SimulSeeSelune_p_Extinct_WithOverlap.R")
source("SimulSeeSelune_p_Extint_WithoutOverlap.R")


# ----------------------------------------------------------------------------------
# Figure - Probability of extinction
# ----------------------------------------------------------------------------------

# Use p_extinct_with_overlap and p_extinct_without_overlap


def.par <- par(no.readonly = TRUE)

# windows()

res <- 6
name_figure <- "ProbExtinction.png"
png(filename = name_figure, height = 500*res, width = 500*res, res=72*res)

par(mar=c(5,5,3,3), bty="n")
size.text <- 1.3

x <- hvarie

plot(x ,p_extinct_with_overlap, ylab = "", xlab = "", xaxt="n", yaxt="n", main="", 
     xlim = c(0,0.40), ylim=c(0,1), col = "black", type = "l", lty = 1, lwd = 3)
points(x ,p_extinct_without_overlap, ylab = "", xlab = "", xaxt="n", yaxt="n", main="", 
     xlim = c(0,0.40), ylim=c(0,1), col = "black", type = "l", lty = 2, lwd = 3)

axis(side = 1, tick = T, cex.axis=1, las=1)
axis(side = 2, tick = T, cex.axis=1)
mtext(side=1, "Exploitation rate (h)", bty="n",line=3, cex = size.text)
mtext(side=2, "Prob. of extinction", bty="n", line=3, cex = size.text)

# legend(	legend = c("With generation overlap","Without generation overlap"),
# 		col = c("black","black"), 	
# 		lty = c(1,2), lwd = c(2,2), x = "topright", cex = 1, bty ="n") 

par(def.par)

dev.off()
