Decision <- function(N1,p1,debut1,fin1,N2,p2,debut2,fin2,TAC,TAC2,Sopt,regle,rythme)	{
#version du 12 mai avec des TAC en individus (voir routinedecision2 pour oeufs) et une regle readapte par estimation
#La semaine t, les saumons arrivent d abord ds la riviere puis on est pech
#la premiere semaine du fichier rythme est la 12 eme de l anne calendaire
# D Decision : vector D1,D2,fin2
#N1 : total return of 1 sea winter
#p1=0.05 prob of capt 1sw per week
#N2 : total return of 2 sea winter
#p2=0.051 prob of capt 2sw per week
# debut : date ouverture de peche
# fin : date fermeture de peche
# TAC : tac total (or NA)
# TAC2: sous tac 2Sea Winter (or NA)
# rythme : matrice 33*2 du rythme des retours
#1= semaine du 15 mars, 32= semaine du 31octobre
#regle = 0 taux d'exploitation constant
#regle = 1 tac global


dateval=15
WeeklyProb1=rythme[,1]
R1<-rmultinom(1,s=N1,p=WeeklyProb1)
StochInRiver1<-cumsum(R1)
C1<-R1*0
for (t in debut1:fin1){C1[t]=rbinom(1,StochInRiver1[t],p1)
					  StochInRiver1[t+1]=StochInRiver1[t]-C1[t]+R1[t+1]
                     }
WeeklyProb2=rythme[,2]
R2<-rmultinom(1,s=N2,p=WeeklyProb2)
StochInRiver2<-cumsum(R2)
C2<-R2*0
for (t in debut2:fin2){C2[t]=rbinom(1,StochInRiver2[t],p2)
					  StochInRiver2[t+1]=StochInRiver2[t]-C2[t]+R2[t+1]
                     }
if (regle =="tauxconstant") {
				 D1<-sum(C1)
				 D2<-sum(C2)
				datefin<-fin1 }

if (regle == "tacglobal")   {#datefin <-sum((cumsum(C1)*fec1*pf1+cumsum(C2)*fec2*pf2)<TAC)
                      datefin <-sum(cumsum(C1)+cumsum(C2)<TAC)
				 D1<-sum(C1[1:datefin])
				 D2<-sum(C2[1:datefin])
								}
if (regle == "tacsoustac")   {datefin <-sum((cumsum(C1)+cumsum(C2))<TAC)
                              datefin2 <-sum((cumsum(C2))<TAC2)
                              datefin2<-min(datefin,datefin2)
					D2<-sum(C2[1:datefin2])
                              datefin <-sum((cumsum(C1)+D2)<TAC)
				      D1<-sum(C1[1:datefin])				
								}

if (regle == "tacrev1")   { #reev=(StochInRiver1[dateval]*fec1*pf1+StochInRiver2[dateval]*fec2*pf2)/Sopt
                            reev=( sum(C1[1:dateval])+ sum(C2[1:dateval]))*280/72/Sopt

                TACdef<-TAC
				if (reev<0.5){TACdef<-0.66*TAC}
               if (((reev-1)*(reev-1.5))<0){TACdef<-1.5*TAC}
			    if (reev>1.5){TACdef<-2*TAC}
                datefin <-sum((cumsum(C1)+cumsum(C2))<TACdef)
				 D1<-sum(C1[1:datefin])
				 D2<-sum(C2[1:datefin])
                          }
if (regle == "tacrev2")   { #reev=(StochInRiver1[dateval]*fec1*pf1+StochInRiver2[dateval]*fec2*pf2)/Sopt
                             reev=( sum(C1[1:dateval])+ sum(C2[1:dateval]))*280/72/Sopt
                TACdef<-TAC
				if (reev<0.25){TACdef<-0.33*TAC}
               if (((reev-0.4)*(reev-0.6))<0){TACdef<-2*TAC}
			    if (reev>0.6){TACdef<-4*TAC}
                datefin <-sum((cumsum(C1)+cumsum(C2))<TACdef)
				 D1<-sum(C1[1:datefin])
				 D2<-sum(C2[1:datefin]) 
							 }

y<-c(D1,D2,datefin)
return(y)}

Decisionmvt <- function(N1mvt,p1,debut1,fin1,N2mvt,p2,debut2,fin2,TAC,TAC2,Sopt,regle,rythme)	{
d<-matrix(0,nr=length(N1mvt),nc=3)
for(m in 1:length(N1mvt) ){
N1<-N1mvt[m]
N2<-N2mvt[m]
d[m,1:3]<-Decision(N1,p1,debut1,fin1,N2,p2,debut2,fin2,TAC,TAC2,Sopt,regle,rythme)	
}
return(d)
}
Benef<-function(C1,C2,p1,p2,p3,R1,R2){
s=p1*C1+p2*C2-p3*(C1/R1+C2/R2)
return(s)
}